from config import FTP_CLIENT_ENCODING

from ZServer.medusa.ftp_server import ftp_channel, xmit_channel, filesys
original_found_terminator = ftp_channel.found_terminator
def found_terminator(self):
    self.in_buffer = unicode(self.in_buffer, FTP_CLIENT_ENCODING).encode('utf8')
    result = ''
    return original_found_terminator(self)
ftp_channel.found_terminator = found_terminator

from asynchat import async_chat
original_push_with_producer = async_chat.push_with_producer

from ZServer.medusa.producers import file_producer, simple_producer

class encoding_wrapper_producer:
    def __init__(self, producer, fromEncoding='utf8', toEncoding=FTP_CLIENT_ENCODING):
        self.fromEncoding = fromEncoding
        self.toEncoding = toEncoding
        self.producer = producer

    def more(self):
        return self.producer.more().decode(self.fromEncoding).encode(self.toEncoding)

from types import StringType
def push(self, producer, encoding=True):
    if type(producer) is StringType:
        producer = simple_producer(producer)
    # don't do codec when upload a file
    if encoding and not isinstance(producer, file_producer):
        producer = encoding_wrapper_producer(producer)
    return original_push_with_producer(self, producer)

ftp_channel.push_with_producer = push
xmit_channel.push_with_producer = push
ftp_channel.push  = push
xmit_channel.push = push

from ZServer.FTPServer import zope_ftp_channel
zope_ftp_channel.push_with_producer = push
zope_ftp_channel.push = push
import asynchat

# don't do codec when download files
def retr_completion(self, file, response):
        status=response.getStatus()
        if status==200:
            self.make_xmit_channel()
            if not response._wrote:
                # chrism: we explicitly use a large-buffered producer here to
                # increase speed.  Using "client_dc.push" with the body causes
                # a simple producer with a buffer size of 512 to be created
                # to serve the data, and it's very slow
                # (about 100 times slower than the large-buffered producer)
                self.client_dc.push_with_producer(
                    asynchat.simple_producer(response.body, 1<<16), False)
                # chrism: if the response has a bodyproducer, it means that
                # the actual body was likely an empty string.  This happens
                # typically when someone returns a StreamIterator from
                # Zope application code.
                if response._bodyproducer:
                    self.client_dc.push_with_producer(response._bodyproducer, False)
            else:
                for producer in self._response_producers:
                    self.client_dc.push_with_producer(producer, False)
            self._response_producers = None
            self.client_dc.close_when_done()
            self.respond(
                    "150 Opening %s mode data connection for file '%s'" % (
                        self.type_map[self.current_mode],
                        file
                        ))
        elif status in (401, 403):
            self.respond('530 Unauthorized.')
        else:
            self.respond('550 Error opening file.')
zope_ftp_channel.retr_completion = retr_completion

